<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CS 250 Data Structures: DataStructure::ILinearDataStructure&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CS 250 Data Structures
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespaceDataStructure.html">DataStructure</a></li><li class="navelem"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html">ILinearDataStructure</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classDataStructure_1_1ILinearDataStructure-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">DataStructure::ILinearDataStructure&lt; T &gt; Class Template Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>An interface of methods that our linear data structures should have.  
 <a href="classDataStructure_1_1ILinearDataStructure.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="ILinearDataStructure_8h_source.html">ILinearDataStructure.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for DataStructure::ILinearDataStructure&lt; T &gt;:</div>
<div class="dyncontent">
<div class="center"><img src="classDataStructure_1_1ILinearDataStructure__inherit__graph.png" border="0" usemap="#DataStructure_1_1ILinearDataStructure_3_01T_01_4_inherit__map" alt="Inheritance graph"/></div>
<map name="DataStructure_1_1ILinearDataStructure_3_01T_01_4_inherit__map" id="DataStructure_1_1ILinearDataStructure_3_01T_01_4_inherit__map">
<area shape="rect" title="An interface of methods that our linear data structures should have." alt="" coords="15,5,194,47"/>
<area shape="rect" href="classDataStructure_1_1SmartDynamicArray.html" title="A data structure that wraps a dynamic array." alt="" coords="5,95,204,136"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a89b6ec4072e80a7da930ca615de93fa9"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#a89b6ec4072e80a7da930ca615de93fa9">~ILinearDataStructure</a> ()</td></tr>
<tr class="separator:a89b6ec4072e80a7da930ca615de93fa9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa1419574042c1e203213373f1ba6f145"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#aa1419574042c1e203213373f1ba6f145">PushBack</a> (T newItem)=0</td></tr>
<tr class="memdesc:aa1419574042c1e203213373f1ba6f145"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert an item to the END of the array.  <a href="classDataStructure_1_1ILinearDataStructure.html#aa1419574042c1e203213373f1ba6f145">More...</a><br /></td></tr>
<tr class="separator:aa1419574042c1e203213373f1ba6f145"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f5e5a61569049ed6c9cca73b09a8f35"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#a1f5e5a61569049ed6c9cca73b09a8f35">PushFront</a> (T newItem)=0</td></tr>
<tr class="memdesc:a1f5e5a61569049ed6c9cca73b09a8f35"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert an item to the BEGINNING of the array.  <a href="classDataStructure_1_1ILinearDataStructure.html#a1f5e5a61569049ed6c9cca73b09a8f35">More...</a><br /></td></tr>
<tr class="separator:a1f5e5a61569049ed6c9cca73b09a8f35"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1e59043148371d81c50c031ffd19f68"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#ab1e59043148371d81c50c031ffd19f68">PushAt</a> (T newItem, int index)=0</td></tr>
<tr class="memdesc:ab1e59043148371d81c50c031ffd19f68"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert an item at some index in the array.  <a href="classDataStructure_1_1ILinearDataStructure.html#ab1e59043148371d81c50c031ffd19f68">More...</a><br /></td></tr>
<tr class="separator:ab1e59043148371d81c50c031ffd19f68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a986d42fc26825723fe402b93fdfdd789"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#a986d42fc26825723fe402b93fdfdd789">PopBack</a> ()=0</td></tr>
<tr class="memdesc:a986d42fc26825723fe402b93fdfdd789"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove the LAST item in the array.  <a href="classDataStructure_1_1ILinearDataStructure.html#a986d42fc26825723fe402b93fdfdd789">More...</a><br /></td></tr>
<tr class="separator:a986d42fc26825723fe402b93fdfdd789"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af04d46ba0d8e403f51bd8b5eecbe4765"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#af04d46ba0d8e403f51bd8b5eecbe4765">PopFront</a> ()=0</td></tr>
<tr class="memdesc:af04d46ba0d8e403f51bd8b5eecbe4765"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove the FRONT item in the array. Shift everything to the left.  <a href="classDataStructure_1_1ILinearDataStructure.html#af04d46ba0d8e403f51bd8b5eecbe4765">More...</a><br /></td></tr>
<tr class="separator:af04d46ba0d8e403f51bd8b5eecbe4765"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad176bfb68eeb51ec4d989e3b039498f0"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#ad176bfb68eeb51ec4d989e3b039498f0">PopAt</a> (int index)=0</td></tr>
<tr class="memdesc:ad176bfb68eeb51ec4d989e3b039498f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove an item in the middle of the array. Close up the gap.  <a href="classDataStructure_1_1ILinearDataStructure.html#ad176bfb68eeb51ec4d989e3b039498f0">More...</a><br /></td></tr>
<tr class="separator:ad176bfb68eeb51ec4d989e3b039498f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca00267477d02b4caf7d210c97453ffe"><td class="memItemLeft" align="right" valign="top">virtual T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#aca00267477d02b4caf7d210c97453ffe">GetBack</a> ()=0</td></tr>
<tr class="memdesc:aca00267477d02b4caf7d210c97453ffe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the LAST item in the array.  <a href="classDataStructure_1_1ILinearDataStructure.html#aca00267477d02b4caf7d210c97453ffe">More...</a><br /></td></tr>
<tr class="separator:aca00267477d02b4caf7d210c97453ffe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75425e075a62d7ba36d226aeffadc128"><td class="memItemLeft" align="right" valign="top">virtual T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#a75425e075a62d7ba36d226aeffadc128">GetFront</a> ()=0</td></tr>
<tr class="memdesc:a75425e075a62d7ba36d226aeffadc128"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the FIRST item in the array.  <a href="classDataStructure_1_1ILinearDataStructure.html#a75425e075a62d7ba36d226aeffadc128">More...</a><br /></td></tr>
<tr class="separator:a75425e075a62d7ba36d226aeffadc128"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a752f83d872da38bc6c24f18943865bc5"><td class="memItemLeft" align="right" valign="top">virtual T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#a752f83d872da38bc6c24f18943865bc5">GetAt</a> (int index)=0</td></tr>
<tr class="memdesc:a752f83d872da38bc6c24f18943865bc5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get an item in the array at some index.  <a href="classDataStructure_1_1ILinearDataStructure.html#a752f83d872da38bc6c24f18943865bc5">More...</a><br /></td></tr>
<tr class="separator:a752f83d872da38bc6c24f18943865bc5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada9291d891e589cdc03a80529815fea0"><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#ada9291d891e589cdc03a80529815fea0">Size</a> () const =0</td></tr>
<tr class="memdesc:ada9291d891e589cdc03a80529815fea0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the amount of items currently stored in the array.  <a href="classDataStructure_1_1ILinearDataStructure.html#ada9291d891e589cdc03a80529815fea0">More...</a><br /></td></tr>
<tr class="separator:ada9291d891e589cdc03a80529815fea0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75270cd9f05e06f8fa61e712adb2793a"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDataStructure_1_1ILinearDataStructure.html#a75270cd9f05e06f8fa61e712adb2793a">IsEmpty</a> () const =0</td></tr>
<tr class="memdesc:a75270cd9f05e06f8fa61e712adb2793a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check if the array is currently empty.  <a href="classDataStructure_1_1ILinearDataStructure.html#a75270cd9f05e06f8fa61e712adb2793a">More...</a><br /></td></tr>
<tr class="separator:a75270cd9f05e06f8fa61e712adb2793a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br />
class DataStructure::ILinearDataStructure&lt; T &gt;</h3>

<p>An interface of methods that our linear data structures should have. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a89b6ec4072e80a7da930ca615de93fa9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a89b6ec4072e80a7da930ca615de93fa9">&#9670;&nbsp;</a></span>~ILinearDataStructure()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::~<a class="el" href="classDataStructure_1_1ILinearDataStructure.html">ILinearDataStructure</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a752f83d872da38bc6c24f18943865bc5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a752f83d872da38bc6c24f18943865bc5">&#9670;&nbsp;</a></span>GetAt()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual T&amp; <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::GetAt </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get an item in the array at some index. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a7d331e5248c7fc4acd78a6b6bfaa948e">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="aca00267477d02b4caf7d210c97453ffe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aca00267477d02b4caf7d210c97453ffe">&#9670;&nbsp;</a></span>GetBack()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual T&amp; <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::GetBack </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the LAST item in the array. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a1fefb845be39b085318ffce09be71364">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a75425e075a62d7ba36d226aeffadc128"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a75425e075a62d7ba36d226aeffadc128">&#9670;&nbsp;</a></span>GetFront()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual T&amp; <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::GetFront </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the FIRST item in the array. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a38e5261034d4ac6d3e1f3bcee500c805">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a75270cd9f05e06f8fa61e712adb2793a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a75270cd9f05e06f8fa61e712adb2793a">&#9670;&nbsp;</a></span>IsEmpty()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::IsEmpty </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Check if the array is currently empty. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a426fef927621111c1be401c7fa73fe04">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ad176bfb68eeb51ec4d989e3b039498f0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad176bfb68eeb51ec4d989e3b039498f0">&#9670;&nbsp;</a></span>PopAt()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::PopAt </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Remove an item in the middle of the array. Close up the gap. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a57a5d4f356b91b24587be9418064ec85">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a986d42fc26825723fe402b93fdfdd789"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a986d42fc26825723fe402b93fdfdd789">&#9670;&nbsp;</a></span>PopBack()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::PopBack </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Remove the LAST item in the array. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a5dd233281c39bde8f886ef0658466a29">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="af04d46ba0d8e403f51bd8b5eecbe4765"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af04d46ba0d8e403f51bd8b5eecbe4765">&#9670;&nbsp;</a></span>PopFront()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::PopFront </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Remove the FRONT item in the array. Shift everything to the left. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a2b327554f75cb1ae6a149804de8d94ad">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ab1e59043148371d81c50c031ffd19f68"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab1e59043148371d81c50c031ffd19f68">&#9670;&nbsp;</a></span>PushAt()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::PushAt </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>newItem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>index</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Insert an item at some index in the array. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a972caa1466e5c7a447c4890cfe5ff71c">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="aa1419574042c1e203213373f1ba6f145"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa1419574042c1e203213373f1ba6f145">&#9670;&nbsp;</a></span>PushBack()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::PushBack </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>newItem</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Insert an item to the END of the array. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a44cb3444992367a35d20709d3060f9a0">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a1f5e5a61569049ed6c9cca73b09a8f35"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f5e5a61569049ed6c9cca73b09a8f35">&#9670;&nbsp;</a></span>PushFront()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::PushFront </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>newItem</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Insert an item to the BEGINNING of the array. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#a9daad437cfb07658035fb8eefba9980e">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ada9291d891e589cdc03a80529815fea0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada9291d891e589cdc03a80529815fea0">&#9670;&nbsp;</a></span>Size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual int <a class="el" href="classDataStructure_1_1ILinearDataStructure.html">DataStructure::ILinearDataStructure</a>&lt; T &gt;::Size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the amount of items currently stored in the array. </p>

<p>Implemented in <a class="el" href="classDataStructure_1_1SmartDynamicArray.html#adde53eaea043a0a41d235bc0b8dbfd60">DataStructure::SmartDynamicArray&lt; T &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>DataStructure/Interfaces/<a class="el" href="ILinearDataStructure_8h_source.html">ILinearDataStructure.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
